SystemOrganization addCategory: #'IRDA2013-sorting2-SorterClasses'!

Object subclass: #S2AbstractFocusedIndicesEvaluator
	instanceVariableNames: 'listPartSorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractFocusedIndicesEvaluator class methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:37:17.436'!
newWithListPartSorter: aListPartSorter
|me|
	me := self new.
	me listPartSorter: aListPartSorter.
	^me.! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 13:14:30.467'!
compareElementsWithLeft: left withRight: right withPivot: pivot
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 16:05:36.312'!
compareFocusedElementsInList: list
	^self compareElementsWithLeft: (list firstFocusedElement) 
		withRight: (list secondFocusedElement) 
		withPivot: list pivot.! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 16:07:35.371'!
evaluateFocusedElements
|list|
	list := self listPartSorter sorter list.
	(self compareFocusedElementsInList: list) ifTrue: [
		self switchFocusedElementsInList: list.
	].! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:37:26.988'!
listPartSorter

	^ listPartSorter! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:37:27.012'!
listPartSorter: anObject

	listPartSorter := anObject! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 16:14:54.81'!
switchFocusedElementsInList: list
	list switchElementAt: (list firstFocusedElement)
		withElementAt: (list secondFocusedElement).! !

S2AbstractFocusedIndicesEvaluator subclass: #S2QuicksortFocusedIndicesEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 13:32:53.579'!
compareElementsWithLeft: left withRight: right withPivot: pivot
	^(left > pivot) and: (right < pivot).! !

Object subclass: #S2AbstractFocusedIndicesFinder
	instanceVariableNames: 'listPartSorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractFocusedIndicesFinder class methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:36:29.473'!
newWithListPartSorter: aListPartSorter
|me|
	me := self new.
	me listPartSorter: aListPartSorter.
	^me.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:36:50.511'!
listPartSorter

	^ listPartSorter! !

!S2AbstractFocusedIndicesFinder methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:36:50.527'!
listPartSorter: anObject

	listPartSorter := anObject! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/16/2013 16:25:08.491'!
nextFocusedElementsIndicesInList: list
	(self shouldUpdateLeft: (list firstFocusedElement) withPivot: (list pivotElement))
		ifTrue: [list updateFirstFocusedIndex: (self updateLeftIndex: list firstFocusedIndex)]
		ifFalse: [
			(self shouldUpdateRight: (list secondFocusedElement) withPivot: (list pivotElement))
				ifTrue: [list updateSecondFocusedIndex: (self updateRightIndex: (list secondFocusedIndex))]].! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/16/2013 16:18:43.915'!
nextFocusedElementsIndicesWithCurrentFocus: focus inList: elements
| pivot |
	pivot := elements at: focus third.
	(self shouldUpdateLeft: (elements at: focus first) withPivot: pivot)
		ifTrue: [focus at: 1 put: (self updateLeftIndex: focus first)]
		ifFalse: [
			(self shouldUpdateRight: (elements at: focus second) withPivot: pivot)
				ifTrue: [focus at: 2 put: (self updateRightIndex: focus second)]].! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/16/2013 12:25:59.305'!
nextLeftFocusWithCurrentFocus: focus inList: elements
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/16/2013 12:26:02.715'!
nextPivotWithCurrentFocus: focus inList: elements
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/16/2013 12:26:06.515'!
nextRightFocusWithCurrentFocus: focus inList: elements
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/16/2013 16:16:51.697'!
updateFocusedElementsIndices
|list i j|
	list := self listPartSorter sorter list.
	i := list firstFocusedElement.
	j := list secondFocusedElement.
	self nextFocusedElementsIndicesInList: self listPartSorter sorter list.
	"The focus should change each time. If not, something went wrong."
	(i = list firstFocusedElement and: (j = list secondFocusedElement)) ifTrue: [
		self error: 'I got stuck'.].! !

S2AbstractFocusedIndicesFinder subclass: #S2QuicksortFocusedIndicesFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:45:51.557'!
nextFocusedElementsIndicesWithCurrentFocus: focus inList: elements
| pivot |
	pivot := elements at: focus third.
	(self shouldUpdateLeft: (elements at: focus first) withPivot: pivot)
		ifTrue: [focus at: 1 put: (self updateLeftIndex: focus first)]
		ifFalse: [
			(self shouldUpdateRight: (elements at: focus second) withPivot: pivot)
				ifTrue: [focus at: 2 put: (self updateRightIndex: focus second)]].! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 12:49:54.942'!
nextLeftFocusWithCurrentFocus: focus inList: elements
|pivot leftIdx|
	pivot := elements at: focus third.
	leftIdx := focus first.
	((elements at: leftIdx) < pivot) ifTrue: [ leftIdx := leftIdx + 1 ].
	^leftIdx.! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 12:51:34.254'!
nextPivotWithCurrentFocus: focus inList: elements
	^focus third! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 12:50:14.308'!
nextRightFocusWithCurrentFocus: focus inList: elements
|pivot rightIdx|
	pivot := elements at: focus third.
	rightIdx := focus second.
	((elements at: rightIdx) > pivot) ifTrue: [ rightIdx := rightIdx - 1 ].
	^rightIdx.! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:09:54.752'!
shouldUpdateLeft: left withPivot: pivot
	^(left <= pivot)! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:09:59.435'!
shouldUpdateRight: right withPivot: pivot
	^(right >= pivot)! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 13:55:41.082'!
updateLeftIndex: leftIdx
	^leftIdx + 1! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:00:12.656'!
updateRightIndex: rightIdx
	^rightIdx-1! !

Object subclass: #S2AbstractIterator
	instanceVariableNames: 'sorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractIterator class methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 18:04:11.464'!
newWithSorter: aSorter
|me|
	me := self new.
	me sorter: aSorter.
	^me.! !

!S2AbstractIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:56:33.83'!
nextFocusedIndicesIteration
	^self sorter list leftFocusedIndex < self sorter list rightFocusedIndex.! !

!S2AbstractIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 18:02:43.528'!
nextListPartIteration
	^(self sorter list elements size = self sorter list sortedIndices size) not! !

!S2AbstractIterator methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:45.465'!
sorter

	^ sorter! !

!S2AbstractIterator methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:45.48'!
sorter: anObject

	sorter := anObject! !

Object subclass: #S2AbstractListPartFinder
	instanceVariableNames: 'sorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractListPartFinder class methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 18:04:18.423'!
newWithSorter: aSorter
|me|
	me := self new.
	me sorter: aSorter.
	^me.! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 17:32:56.591'!
findLeftIndex
	^self subclassResponsibility.! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 17:09:34.584'!
findRightIndex
	self subclassResponsibility.! !

!S2AbstractListPartFinder methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:29.794'!
sorter

	^ sorter! !

!S2AbstractListPartFinder methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:29.81'!
sorter: anObject

	sorter := anObject! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:28:57.544'!
updateListPartIndices
|left right|
	left := self findLeftIndex.
	right := self findRightIndex.
	self sorter list listPartIndices at: 1 put: left.
	self sorter list listPartIndices at: 2 put: right.! !

S2AbstractListPartFinder subclass: #S2QuicksortListPartFinder
	instanceVariableNames: 'left'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 10:47:16.487'!
findLeftIndex
"Finds the first index that is not sorted yet"
	^self findLeftIndexInListWithLength: (self sorter list elements size) withSortedIndices: (self sorter list sortedIndices).! !

!S2QuicksortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 10:56:27.903'!
findLeftIndexInListWithLength: l withSortedIndices: sorted
	"Finds the first index that is not sorted yet"
	^(1 to: l) detect: [:ea | (sorted includes: ea) not] ifNone: [nil].! !

!S2QuicksortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:51:16.043'!
findRightIndex
	^self findRightIndexInListWithLength: (self sorter list elements size) 
		withSortedIndices: (self sorter list sortedIndices).! !

!S2QuicksortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:50:57.763'!
findRightIndexInListWithLength: l withSortedIndices: sorted
	^(1 to: l) detect: [:ea | 
		(sorted includes: (ea)) not and: ((sorted includes: ea + 1) or: (ea = l)).
	] ifNone: [nil].! !

!S2QuicksortListPartFinder methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:21:30.06'!
left

	^ left! !

!S2QuicksortListPartFinder methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:21:30.076'!
left: anObject

	left := anObject! !

Object subclass: #S2AbstractListPartSorter
	instanceVariableNames: 'sorter focusedIndexFinder focusedIndexEvaluator iterator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractListPartSorter class methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:42:22.564'!
newWithSorter: aSorter
|me|
	me := self new.
	me sorter: aSorter.
	me iterator: aSorter iterator.
	^me.! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.342'!
focusedIndexEvaluator

	^ focusedIndexEvaluator! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.353'!
focusedIndexEvaluator: anObject

	focusedIndexEvaluator := anObject! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.312'!
focusedIndexFinder

	^ focusedIndexFinder! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.328'!
focusedIndexFinder: anObject

	focusedIndexFinder := anObject! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:47:32.688'!
initialize
	super initialize.
	self focusedIndexFinder: (S2QuicksortFocusedIndicesFinder newWithListPartSorter: self).
	self focusedIndexEvaluator: (S2QuicksortFocusedIndicesEvaluator newWithListPartSorter: self).! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:56:37.152'!
initializeFocusedIndices
|focus bounds |
	focus := self sorter list focusedIndices.
	bounds := self sorter list listPartIndices.
	self initializeFocusedIndices: focus withLeftBound: (bounds first) withRightBound: (bounds second)! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:55:12.811'!
initializeFocusedIndices: focus withLeftBound: left withRightBound: right
	^self subclassResponsibility.! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.371'!
iterator

	^ iterator! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.383'!
iterator: anObject

	iterator := anObject! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:52:56.774'!
resetFocusedIndices
|focus|
	focus := self sorter list focusedIndices.
	focus at: 1 put: nil.
	focus at: 2 put: nil.
	focus at: 3 put: nil.! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:03:48.004'!
sortListPart
	self initializeFocusedIndices.
	[ self iterator nextFocusedIndicesIteration ] whileTrue: 
		[ self focusedIndexFinder updateFocusedElementsIndices.
		self focusedIndexEvaluator evaluateFocusedElements.].
	self updatePivotPosition.
	self updateSortedIndices.
	self resetFocusedIndices.! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:36.684'!
sorter

	^ sorter! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:36.7'!
sorter: anObject

	sorter := anObject! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 13:42:24.924'!
updatePivotPosition
	^self subclassResponsibility.! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 13:41:55.516'!
updateSortedIndices
	^self subclassResponsibility.! !

S2AbstractListPartSorter subclass: #S2QuicksortListPartSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:01:10.95'!
initializeFocusedIndices: focus withLeftBound: left withRightBound: right
	focus at: 1 put: left.
	focus at: 2 put: right - 1.
	focus at: 3 put: right.
	! !

!S2QuicksortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:27:22.905'!
updatePivotPosition
	self halt.! !

Object subclass: #S2AbstractSorter
	instanceVariableNames: 'list iterator listPartFinder listPartSorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractSorter class methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 17:38:57.102'!
newWithList: anObject
|me|
	me := self new.
	me setupList: anObject.
	^me.! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 18:04:56.442'!
initialize
	super initialize.
	self iterator: (S2AbstractIterator newWithSorter: self).! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.445'!
iterator

	^ iterator! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.458'!
iterator: anObject

	iterator := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.416'!
list

	^ list! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:42:16.782'!
list: anObject
	list := S2List new.
	list setupList: anObject.! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.476'!
listPartFinder

	^ listPartFinder! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.489'!
listPartFinder: anObject

	listPartFinder := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.5'!
listPartSorter

	^ listPartSorter! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.511'!
listPartSorter: anObject

	listPartSorter := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:12:31.147'!
setupList: anObject
	self list: anObject asOrderedCollection.! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:30:34.402'!
sort
	[ self iterator nextListPartIteration ] whileTrue: 
		[ self listPartFinder updateListPartIndices.
		self listPartSorter sortListPart.].! !

S2AbstractSorter subclass: #S2Quicksorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2Quicksorter methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 18:05:20.453'!
initialize
	super initialize.
	self listPartFinder: (S2QuicksortListPartFinder newWithSorter: self).
	self listPartSorter: (S2QuicksortListPartSorter newWithSorter: self).! !

!S2Quicksorter methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:50:04.806'!
setupList: anObject
	super setupList: anObject.
	self list listPartIndices at: 1 put: 1.
	self list listPartIndices at: 2 put: self list elements size.! !

Object subclass: #S2List
	instanceVariableNames: 'sortedIndices elements leftBoundIndex rightBoundIndex firstFocusedIndex secondFocusedIndex pivotIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2List methodsFor: 'updating' stamp: 'AT 6/16/2013 15:59:05.532'!
addIndexAsSorted: idx
	self sortedIndices add: idx.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:01:33.217'!
elements

	^ elements! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:40.812'!
elements: anObject

	elements := anObject.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:27:07.962'!
firstFocusedElement

	^ self elements at: self firstFocusedIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.685'!
firstFocusedIndex

	^ firstFocusedIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.759'!
firstFocusedIndex: anObject

	firstFocusedIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:26.285'!
initialize
	super initialize.
	self elements: #();
		sortedIndices: #().! !

!S2List methodsFor: 'updating' stamp: 'AT 6/16/2013 15:48:01.127'!
insertPivotAt: p
|templeft tempmiddle tempright copy|
	copy := self elements copy.
	(self pivot > p) 
		ifTrue: [templeft := self elements copyFrom: 1 to: p.
			tempmiddle := self elements copyFrom: p to: self pivot.
			tempright := self elements copyFrom: (self pivot + 1) to: self elements size.
			self elements: templeft,(self elements at: pivot),tempmiddle, tempright.]
		ifFalse: [templeft := self elements copyFrom: 1 to: (self pivot).
			tempmiddle := self elements copyFrom: (self pivot + 1) to: p.
			tempright := self elements copyFrom: p to: self elements size.
			self elements: templeft,tempmiddle,(self elements at: pivot), tempright.].
	! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.305'!
leftBoundIndex

	^ leftBoundIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.319'!
leftBoundIndex: anObject

	leftBoundIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:27:27.051'!
pivot

	^ self elements at: self pivotIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.804'!
pivotIndex

	^ pivotIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.817'!
pivotIndex: anObject

	pivotIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.331'!
rightBoundIndex

	^ rightBoundIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.345'!
rightBoundIndex: anObject

	rightBoundIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:27:46.737'!
secondFocusedElement

	^ self elements at: self secondFocusedIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.775'!
secondFocusedIndex

	^ secondFocusedIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.79'!
secondFocusedIndex: anObject

	secondFocusedIndex := anObject! !

!S2List methodsFor: 'initialization' stamp: 'AT 6/16/2013 15:52:12.843'!
setupList: anObject
	self elements: anObject asOrderedCollection;
		leftBoundIndex: 1;
		rightBoundIndex: self elements size.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:09.23'!
sortedIndices

	^ sortedIndices! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:09.248'!
sortedIndices: anObject

	sortedIndices := anObject! !

!S2List methodsFor: 'updating' stamp: 'AT 6/16/2013 15:31:00.627'!
switchElementAt: i withElementAt: j
|temp|
	temp := self elements at: i.
	self elements at: i put: (self elements at: j).
	self elements at: j put: temp.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/16/2013 16:26:15.574'!
updateFirstFocusedIndex: idx
	self firstFocusedIndex: idx.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/16/2013 16:25:35.226'!
updateLeftBoundaryIndex: idx
	self leftBoundIndex: idx.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/16/2013 16:26:02.481'!
updatePivotIndex: idx
	self pivotIndex: idx.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/16/2013 16:25:43.116'!
updateRightBoundaryIndex: idx
	self rightBoundIndex: idx.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/16/2013 16:25:53.754'!
updateSecondFocusedIndex: idx
	self secondFocusedIndex: idx.! !
